
local min,max,round in math
local clipped_box,display_text, set_frame_color4,_empty in _ENV
local format in string


UI_File | function(_ENV)
  

  local white = function() set_frame_color4(1,1,1,1)end

  local function text_frame(x,y,w,h)
    local el = element(x,y-2,w,h+3)
    return el
  end

  local  drawer_t,mounts,mount_info,num_mounts,
    mount_mod_conflicts,
    filled_mounts,prefered_hardpoint_type,get_prefered_drawer

  function hardpoint_cache_active_vars()

    drawer_t,mounts,mount_info,num_mounts,
    mount_mod_conflicts,
     filled_mounts,prefered_hardpoint_type, get_prefered_drawer
      in ( active_vars or generator(nil) )

  end

  if(active_design)
    hardpoint_cache_active_vars()
  end


  local font_h




  local function colored_item_box(x,y,i)

    local dragging in active_vars
    local subbox in skin.hardpoints
    local rx,ry,rw,rh =  subbox.rect()

    local ib = element(rx,ry+y,rw,rh)

    --glBox(rx,ry+y,rw,rh)

    return ib
  end

  function display_hardpoint(mtype)
    if mtype=='Turret'
      return 'Medium'
    elseif mtype=='Transport'
      return 'Hold'
    elseif mtype=='SuperHeavy'
      return 'Siege'
		elseif mtype=='Capacitor'
			return 'Busbar'
    end
    return mtype
  end

  local siege_color = color_param 'eb1c25'

  local mount_typecolor = {
    ["Turret"]=function() set_frame_color4(1,1,0,1) end,
    --["CR Cannon"]=[() set_frame_color4(1,.6,0,1) ],
    ["Reactor"]=function() set_frame_color4(1,.3,0,1) end,
    ["Medium"]=function()  set_frame_color4(1,1,0,1) end,
    ["Heavy"]=function()  set_frame_color4(1,.7,0,1) end,
    ["SuperHeavy"]=function() set_frame_color4 | siege_color() end,
    ["Siege"]=function() set_frame_color4 | siege_color() end,
    ["System"]=function()  set_frame_color4(.1,.9,0,1) end,
    ["Station"]=function()  set_frame_color4(.1,.9,0,1) end,
    ["Outpost"]=function()  set_frame_color4(0,.9,.5,1) end,
    ["Planet"]=function()  set_frame_color4 | hardpoint_icons.semantic_to_color.planet()  end,
    ["Armor"]=function() set_frame_color4 | hardpoint_icons.semantic_to_color.armor() end,
	["System"]=function()  set_frame_color4(.1,.9,0,1) end,
	["Shield"]=function()  set_frame_color4 | hardpoint_icons.semantic_to_color.shield() end,
    ["Built-In"]=function() set_frame_color4(.5,.5,.5,1) end,
    ['Hangar']=function()  set_frame_color4(.3,.4,1,1) end,
    ["Docking"]=function()  set_frame_color4(.3,.4,1,1) end,
    ["Missile"]=function()  set_frame_color4(.3,.4,1,1) end,
    ["Torpedo"]=function()  set_frame_color4(.3,.4,1,1) end,
  }

  function hover_slot(el)
    -- ok, so, this was an interesting idea: limiting the avaiable
    -- list to compatible techs in response to clicks on the
    -- non-icon part of the hardpoint.
    --
    -- it may be a case of trying to expose to many different types
    -- of semantics in a single ui though.  this simple
    -- implementation is problematic, because there's no way to
    -- control scrolling in the limited list, once you've created
    -- it.
    --
    -- i could likely fix that, by adding yet more special
    -- semantics, but, i'm not sure if the result will ever really
    -- be useful.  i mean, it's still an awkward approximation to
    -- an SOTS type interface, and one that people are unlikely to
    -- discover by accident.
    --
    -- there's something to be said, i think, for either doing
    -- something well, or not doing it at all.

    --if active_design.dragging return end

    --if(lmouse_down() or rmouse_down() )
    --	limit_available = Design.mount_allowed_types[available_mounts[el.slot_i].mtype]
    --end

  end


  local mount_type_str = weak_memoize_1_to_1 | function(mount)
    if is_weapon_mtype(mount.mtype) and mount.n

      local divides = mtype_to_divides[mount.mtype] or 1
      local n in mount

      --print 'hi'

      return format("%s %dx",display_hardpoint | mount.mtype, round | n/divides)
    elseif mount.mtype=='Capacitor'
			return 'Busbar'
		else
      return format("%s (%d)",display_hardpoint | mount.mtype,mount.space)
    end
  end

	function mount_desc_text (mount)
		if mount.mtype=='Capacitor' return 'Busbar' end
		return mount.mtype
	end

  local function draw_module(x,y,w,h,el,mount,i)

    el.on_hover = hover_slot
    el.slot_i = i


    local ib = colored_item_box(x,y,i)
    ib.hardpoint_location=i

    --mount.type_str=nil

    local filled_mounts,active_mods in active_design

    el.desc_text = i
    el.hardpoint_location=i

    local label_text = (filled_mounts[i]) and ( display_hardpoint| mount.mtype)
              or mount_type_str(mount)

  
    local subbox in skin.hardpoints

    element(subbox.text(y,"type",label_text,
      mount_typecolor[mount.mtype] or white)).desc_text=mount_desc_text | mount

    --br_text(font_name,type.fh*.7,x+w-2,y+6,label_text)



  end

  local function weapon_name(name, n)
    --local system = name2sys[name]
    local winfo = WEAPONS[name]

    if(not winfo) return end

    return format("%s x %d",name,n)
  end

  local function installed_name(name,i,mods) 

    local mount = active_design.mount_info(i)

    if(mount.n and WEAPONS[name] ) 
      return weapon_name(name, active_design.implied_weapon_n(i,mods) )
    end

    return name

  end

  local interactable_weapon_mods = restore_color( function (ly,name,i,active_mods)
    --local tx,ty,font_h = lastline_pos()

    
    local line2 in skin.hardpoints.subbox

    local tx,ty=table.unpack(line2)
    ty+=ly
    local font_h=line2.fh*.7/.75
    local font_name = skin.hardpoints.subbox.font

    local hide_conflicts=true
    local first_tx=tx

    local mods_str="Mods: "

    if(hide_conflicts)
      tx=tx+displayed_str_len(font_name,font_h,mods_str)
    end


    local dragging,mount_info,mount_mod_conflicts in active_vars
    local mount = mount_info(i)

    

    local mods = empire.part_info[name].unlocked_mods

    if not mods
      return
    end

    local sep=", "
    local seplen=displayed_str_len(font_name,font_h,sep)
    local not_first
    local displayed
    local displayed_inactive

    local conflicts = mount_mod_conflicts[mount.mtype] or _empty

    for k,v in pairs(mods?) do

      local conflicting=conflicts and conflicts[k]
      
      if(conflicting and hide_conflicts)
        goto next
      end
      if(not displayed)
        displayed=true
      end

      if(not_first)
        display_text(font_name,font_h,tx,ty,sep)
        tx=tx+seplen
      else
        not_first=true
      end

      if(conflicting)
        set_frame_color4(.5,.5,.5,1)
      elseif( active_mods[k] )
        set_frame_color4(1,1,1,1)
        displayed=1
      else
        displayed_inactive=true
        if(hide_conflicts)
          set_frame_color4(.5,.5,.5,1)
        else
          set_frame_color4(.3,.6,1,1)
        end
      end


      local str=ABBRVS[k] or k
      display_text(font_name,font_h,tx,ty,str)

      local tx0=tx

      tx=tx+displayed_str_len(font_name,font_h,str)

      if(not dragging)
      
        local xp,yp=2,2
        local el = element(tx0-xp,ty-yp,tx-tx0+2*xp,font_h+2*yp)

        el.mod=k
        el.mount_i=i

      end
      ::next::
    end

    if(hide_conflicts and displayed)
      if(displayed==1)
        --white()
        if(displayed_inactive)
          set_frame_color4(.7,.7,.7,1)
        else
          white()
        end
      else
        set_frame_color4(.5,.5,.5,1)			
      end
      
      display_text(font_name,font_h,first_tx,ty,mods_str)
    else
      set_frame_color4(.5,.5,.5,1)	
      display_text(font_name,font_h,first_tx,ty,"no compatible mods")
    end
    
  end)

 local function draw_mount_icon(x,y,w,h,el,mount,i)
     local subbox in skin.hardpoints
     local rx,ry,rw,rh=subbox.rect()
     ry+=y
		 local _TRACE_INFO = active_design.ship_drawer
     hardpoint_icons.get_mount_icon(mount).draw(rx+rw*.5,ry+rh*.5)

     --glBox(rx,ry,rw,rh)
 end


  local function draw_filled(x,y,w,h,el,mount,i,name,mods)

    local aggressive_alpha=false

    draw_module(x,y,w,h,el,mount, i)

    el.on_hover = hover_slot
    el.slot_i = i

    local sys_el = colored_item_box(x,y,i)
    sys_el.hardpoint_location=i

    local dragging,hover_k,hull_specs in active_vars

    --local hardpoint_type,part_drawer = get_drawer_info(name,mount)
    local subbox in skin.hardpoints



    local system=name2sys[name] or PartInfo[name]

    local subbox in skin.hardpoints

    local _TRACE_INFO = arg_list(..name,..hardpoint_type,..part_drawer,..name)

    --print(..hardpoint_type,..partdrawer)
    --draw_part(name, subbox, x, y, ..mount.mtype, ..ship_drawer)

    do
      local hardpoint_type,part_drawer = FLAG_call('hardpoint_list_draw',active_design.get_drawer_info,name,mount)
      local rx,ry,rw,rh=subbox.rect()
      
      if name=='Stellar Surge Beam'
        --print(..hardpoint_type,..part_drawer)
      end

      if part_drawer
        local palette = part_palette | part_drawer

        SCOPE_call(part_name=name, drawer_table.draw_part_in_box,part_drawer,palette,rx,ry+y,rw,rh)
      --  print('draw in box',palette,part_drawer)
      else 
        error('warning! missing part drawer for',name)
      end

    end


    local color=part_draw_color or white

    --local color = (part_draw_color==invalid_part_color and invalid_part_color) or white

    color()
    if(mods)
      
      subbox.text(y,"title",installed_name(name,i,mods))

    end

    if filled_mounts[i] 
      
      if active_design.cant_modify(mount)
        --print('hihi')
        el.on_hover=info_cursor
      else
        sys_el.on_click=part_clicked
        sys_el.part_i=i
        sys_el.on_hover=hand_cursor
      end

      -- if this is a part we don't have technology for, make it
      -- non-interactable.
      if not name2sys[name]
        sys_el.on_hover=grey_cursor
      end

    end

    if(WEAPONS[name])
      
      subtitle = weapon_subtitle(name,mods, mount_mod_conflicts[mount.mtype])
      
      subbox.text(y,"line1",subtitle)
      
      --if( system.type == "Weapon" )
      interactable_weapon_mods(y,name,i,mods)
   else
      local a=system.sys_action
      if(a)
        subbox.text(y,"line1",a.bonus_string(mount_info(i).space,hull_specs) )
      end

    end

  end

  

  local function determine_draw_option(i)
    local dragging,hover_k in active_vars

    if dragging and not name2sys[dragging] 
      return 'invalid'
    end

    local draw_option=  dragging and 
        (not mount_allowed_types[ mount_info(i).mtype] [name2sys[dragging].type])
        and "invalid"


    if(not draw_option and hover_k==i) 
      draw_option="sel"
    end

    return draw_option

  end

  local function subbox_draw(x,y,i)

    local draw_option= determine_draw_option(i)

    if(draw_option)
      return skin.hardpoints.subbox.alt_draw(draw_option,x,y)
    else
      return skin.hardpoints.subbox.draw(x,y)
    end
  end

  --[[
  function hardpoint_draw()
    if(name)
      boxfun(draw_filled,mount,i,name,mods)
    else
      boxfun(draw_module,mount,i)
    end

  end
  --]]

  local function boxfun(x,y,w,h,el,i,mount,name,mods)


    if name
      draw_filled(x,y,w,h,el,mount,i,name,mods)
    else
      draw_module(x,y,w,h,el,mount,i)
      draw_mount_icon(x,y,w,h,el,mount,i)
    end
  end

  function draw_modules()

    local hardpoints in skin

    local hardpoint_frame in frames!

    hardpoint_frame.draw_bk()


    --hardpoints.subbox.draw=subbox_draw

    hardpoint_frame.emulate_box_list( boxfun, 
      hardpoints!.subbox, subbox_draw,  
      active_design:mounts() )

    hardpoint_frame.draw()
    hardpoint_frame.title()    
    hardpoint_frame.draw_scroll()

  end



end